Index: serefpolicy-contrib-20140730/munin.te
===================================================================
--- serefpolicy-contrib-20140730.orig/munin.te
+++ serefpolicy-contrib-20140730/munin.te
@@ -1,4 +1,4 @@
-policy_module(munin, 1.10.0)
+policy_module(munin, 1.9.1)
 
 ########################################
 #
@@ -44,41 +44,40 @@ files_tmpfs_file(services_munin_plugin_t
 munin_plugin_template(system)
 munin_plugin_template(unconfined)
 
+type munin_script_tmp_t alias httpd_munin_script_tmp_t;
+files_tmp_file(munin_script_tmp_t)
+
 ################################
 #
 # Common munin plugin local policy
 #
 
-allow munin_plugin_domain self:process signal;
+allow munin_plugin_domain self:process signal_perms;
 allow munin_plugin_domain self:fifo_file rw_fifo_file_perms;
 
 allow munin_plugin_domain munin_t:tcp_socket rw_socket_perms;
 
 read_lnk_files_pattern(munin_plugin_domain, munin_etc_t, munin_etc_t)
 
+allow munin_plugin_domain munin_unconfined_plugin_exec_t:file read_file_perms;
+
 allow munin_plugin_domain munin_exec_t:file read_file_perms;
 
 allow munin_plugin_domain munin_var_lib_t:dir search_dir_perms;
 
 manage_files_pattern(munin_plugin_domain, munin_plugin_state_t, munin_plugin_state_t)
 
-kernel_read_system_state(munin_plugin_domain)
-
-corenet_all_recvfrom_unlabeled(munin_plugin_domain)
-corenet_all_recvfrom_netlabel(munin_plugin_domain)
 corenet_tcp_sendrecv_generic_if(munin_plugin_domain)
 corenet_tcp_sendrecv_generic_node(munin_plugin_domain)
 
 corecmd_exec_bin(munin_plugin_domain)
 corecmd_exec_shell(munin_plugin_domain)
 
-files_read_etc_files(munin_plugin_domain)
-files_read_usr_files(munin_plugin_domain)
 files_search_var_lib(munin_plugin_domain)
 
 fs_getattr_all_fs(munin_plugin_domain)
 
-miscfiles_read_localization(munin_plugin_domain)
+auth_read_passwd(munin_plugin_domain)
 
 optional_policy(`
 	nscd_use(munin_plugin_domain)
@@ -118,7 +117,7 @@ manage_dirs_pattern(munin_t, munin_var_l
 manage_files_pattern(munin_t, munin_var_lib_t, munin_var_lib_t)
 manage_lnk_files_pattern(munin_t, munin_var_lib_t, munin_var_lib_t)
 
-read_files_pattern(munin_t, munin_plugin_state_t, munin_plugin_state_t)
+rw_files_pattern(munin_t, munin_plugin_state_t, munin_plugin_state_t)
 
 manage_dirs_pattern(munin_t, munin_var_run_t, munin_var_run_t)
 manage_files_pattern(munin_t, munin_var_run_t, munin_var_run_t)
@@ -134,7 +133,6 @@ kernel_read_all_sysctls(munin_t)
 corecmd_exec_bin(munin_t)
 corecmd_exec_shell(munin_t)
 
-corenet_all_recvfrom_unlabeled(munin_t)
 corenet_all_recvfrom_netlabel(munin_t)
 corenet_tcp_sendrecv_generic_if(munin_t)
 corenet_tcp_sendrecv_generic_node(munin_t)
@@ -157,7 +155,6 @@ domain_use_interactive_fds(munin_t)
 domain_read_all_domains_state(munin_t)
 
 files_read_etc_runtime_files(munin_t)
-files_read_usr_files(munin_t)
 files_list_spool(munin_t)
 
 fs_getattr_all_fs(munin_t)
@@ -169,7 +166,6 @@ logging_send_syslog_msg(munin_t)
 logging_read_all_logs(munin_t)
 
 miscfiles_read_fonts(munin_t)
-miscfiles_read_localization(munin_t)
 miscfiles_setattr_fonts_cache_dirs(munin_t)
 
 sysnet_exec_ifconfig(munin_t)
@@ -177,13 +173,6 @@ sysnet_exec_ifconfig(munin_t)
 userdom_dontaudit_use_unpriv_user_fds(munin_t)
 userdom_dontaudit_search_user_home_dirs(munin_t)
 
-optional_policy(`
-	apache_content_template(munin)
-
-	manage_dirs_pattern(munin_t, httpd_munin_content_t, httpd_munin_content_t)
-	manage_files_pattern(munin_t, httpd_munin_content_t, httpd_munin_content_t)
-	apache_search_sys_content(munin_t)
-')
 
 optional_policy(`
 	cron_system_entry(munin_t, munin_exec_t)
@@ -217,7 +206,6 @@ optional_policy(`
 
 optional_policy(`
 	postfix_list_spool(munin_t)
-	postfix_getattr_all_spool_files(munin_t)
 ')
 
 optional_policy(`
@@ -246,21 +234,23 @@ allow disk_munin_plugin_t self:tcp_socke
 
 rw_files_pattern(disk_munin_plugin_t, munin_var_lib_t, munin_var_lib_t)
 
+kernel_read_fs_sysctls(disk_munin_plugin_t)
+
 corenet_sendrecv_hddtemp_client_packets(disk_munin_plugin_t)
 corenet_tcp_connect_hddtemp_port(disk_munin_plugin_t)
 corenet_tcp_sendrecv_hddtemp_port(disk_munin_plugin_t)
 
-dev_getattr_all_blk_files(disk_munin_plugin_t)
+files_read_etc_runtime_files(disk_munin_plugin_t)
+
 dev_getattr_lvm_control(disk_munin_plugin_t)
 dev_read_sysfs(disk_munin_plugin_t)
 dev_read_urand(disk_munin_plugin_t)
-
-files_read_etc_runtime_files(disk_munin_plugin_t)
+dev_read_all_blk_files(disk_munin_plugin_t)
 
 fs_getattr_all_fs(disk_munin_plugin_t)
 fs_getattr_all_dirs(disk_munin_plugin_t)
 
-storage_getattr_fixed_disk_dev(disk_munin_plugin_t)
+storage_raw_read_fixed_disk(disk_munin_plugin_t)
 
 sysnet_read_config(disk_munin_plugin_t)
 
@@ -272,6 +262,10 @@ optional_policy(`
 	fstools_exec(disk_munin_plugin_t)
 ')
 
+optional_policy(`
+    rpc_search_nfs_state_data(disk_munin_plugin_t)
+')
+
 ####################################
 #
 # Mail local policy
@@ -279,27 +273,38 @@ optional_policy(`
 
 allow mail_munin_plugin_t self:capability dac_override;
 
+allow mail_munin_plugin_t self:tcp_socket create_stream_socket_perms;
+allow mail_munin_plugin_t self:netlink_route_socket r_netlink_socket_perms;
+
 rw_files_pattern(mail_munin_plugin_t, munin_var_lib_t, munin_var_lib_t)
 
+kernel_read_net_sysctls(mail_munin_plugin_t)
+
 dev_read_urand(mail_munin_plugin_t)
 
 logging_read_generic_logs(mail_munin_plugin_t)
 
+sysnet_read_config(mail_munin_plugin_t)
+
+optional_policy(`
+	exim_read_log(mail_munin_plugin_t)
+')
+
 optional_policy(`
-	mta_list_queue(mail_munin_plugin_t)
 	mta_read_config(mail_munin_plugin_t)
-	mta_read_queue(mail_munin_plugin_t)
 	mta_send_mail(mail_munin_plugin_t)
+	mta_list_queue(mail_munin_plugin_t)
+	mta_read_queue(mail_munin_plugin_t)
 ')
 
 optional_policy(`
-	nscd_use(mail_munin_plugin_t)
+	nscd_socket_use(mail_munin_plugin_t)
 ')
 
 optional_policy(`
-	postfix_getattr_all_spool_files(mail_munin_plugin_t)
 	postfix_read_config(mail_munin_plugin_t)
 	postfix_list_spool(mail_munin_plugin_t)
+	postfix_getattr_spool_files(mail_munin_plugin_t)
 ')
 
 optional_policy(`
@@ -339,7 +344,7 @@ dev_read_rand(services_munin_plugin_t)
 sysnet_read_config(services_munin_plugin_t)
 
 optional_policy(`
-	bind_read_config(munin_services_plugin_t)
+	bind_read_config(services_munin_plugin_t)
 ')
 
 optional_policy(`
@@ -361,7 +366,11 @@ optional_policy(`
 ')
 
 optional_policy(`
-	nscd_use(services_munin_plugin_t)
+	nscd_socket_use(services_munin_plugin_t)
+')
+
+optional_policy(`
+	ntp_exec(services_munin_plugin_t)
 ')
 
 optional_policy(`
@@ -393,6 +402,7 @@ read_files_pattern(system_munin_plugin_t
 
 kernel_read_network_state(system_munin_plugin_t)
 kernel_read_all_sysctls(system_munin_plugin_t)
+kernel_read_fs_sysctls(system_munin_plugin_t)
 
 dev_read_sysfs(system_munin_plugin_t)
 dev_read_urand(system_munin_plugin_t)
@@ -421,3 +431,33 @@ optional_policy(`
 optional_policy(`
 	unconfined_domain(unconfined_munin_plugin_t)
 ')
+
+
+#######################################
+#
+# Munin CGI script local policy
+#
+
+apache_content_template(munin)
+apache_content_alias_template(munin, munin)
+
+manage_dirs_pattern(munin_t, munin_content_t, munin_content_t)
+manage_files_pattern(munin_t, munin_content_t, munin_content_t)
+
+manage_dirs_pattern(munin_script_t, munin_script_tmp_t, munin_script_tmp_t)
+manage_files_pattern(munin_script_t, munin_script_tmp_t,munin_script_tmp_t)
+files_tmp_filetrans(munin_script_t, munin_script_tmp_t, { dir file })
+
+read_files_pattern(munin_script_t, munin_var_lib_t, munin_var_lib_t)
+list_dirs_pattern(munin_script_t, munin_etc_t, munin_etc_t)
+read_files_pattern(munin_script_t, munin_etc_t, munin_etc_t)
+
+manage_files_pattern(munin_script_t, munin_log_t, munin_log_t)
+
+files_search_var_lib(munin_script_t)
+
+auth_read_passwd(munin_script_t)
+
+optional_policy(`
+	apache_search_sys_content(munin_t)
+')
Index: serefpolicy-contrib-20140730/mysql.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/mysql.fc
+++ serefpolicy-contrib-20140730/mysql.fc
@@ -1,12 +1,25 @@
-HOME_DIR/\.my\.cnf	--	gen_context(system_u:object_r:mysqld_home_t,s0)
-
-/etc/my\.cnf	--	gen_context(system_u:object_r:mysqld_etc_t,s0)
-/etc/my\.cnf\.d(/.*)?	gen_context(system_u:object_r:mysqld_etc_t,s0)
-/etc/mysql(/.*)?	gen_context(system_u:object_r:mysqld_etc_t,s0)
-
-/etc/rc\.d/init\.d/mysqld?	--	gen_context(system_u:object_r:mysqld_initrc_exec_t,s0)
-/etc/rc\.d/init\.d/mysqlmanager	--	gen_context(system_u:object_r:mysqlmanagerd_initrc_exec_t,s0)
+# mysql database server
 
+#
+# /HOME
+#
+HOME_DIR/\.my\.cnf -- gen_context(system_u:object_r:mysqld_home_t, s0)
+/root/\.my\.cnf -- gen_context(system_u:object_r:mysqld_home_t, s0)
+
+/usr/lib/systemd/system/mysqld.*	--	gen_context(system_u:object_r:mysqld_unit_file_t,s0)
+/usr/lib/systemd/system/mariadb.*   --  gen_context(system_u:object_r:mysqld_unit_file_t,s0)
+
+#
+# /etc
+#
+/etc/my\.cnf		--	gen_context(system_u:object_r:mysqld_etc_t,s0)
+/etc/mysql(/.*)?		gen_context(system_u:object_r:mysqld_etc_t,s0)
+/etc/rc\.d/init\.d/mysqld --	gen_context(system_u:object_r:mysqld_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/mysqlmanager -- gen_context(system_u:object_r:mysqlmanagerd_initrc_exec_t,s0)
+
+#
+# /usr
+#
 /usr/bin/mysqld_safe	--	gen_context(system_u:object_r:mysqld_safe_exec_t,s0)
 /usr/bin/mysql_upgrade	--	gen_context(system_u:object_r:mysqld_exec_t,s0)
 
@@ -14,14 +27,17 @@ HOME_DIR/\.my\.cnf	--	gen_context(system
 
 /usr/sbin/mysqld(-max)?	--	gen_context(system_u:object_r:mysqld_exec_t,s0)
 /usr/sbin/mysqlmanager	--	gen_context(system_u:object_r:mysqlmanagerd_exec_t,s0)
-/usr/sbin/ndbd	--	gen_context(system_u:object_r:mysqld_exec_t,s0)
+/usr/sbin/ndbd		--	gen_context(system_u:object_r:mysqld_exec_t,s0)
 
-/var/lib/mysql(/.*)?	gen_context(system_u:object_r:mysqld_db_t,s0)
-/var/lib/mysql/mysql.*	-s	gen_context(system_u:object_r:mysqld_var_run_t,s0)
+#
+# /var
+#
+/var/lib/mysql(/.*)?		gen_context(system_u:object_r:mysqld_db_t,s0)
+/var/lib/mysql/mysql\.sock -s	gen_context(system_u:object_r:mysqld_var_run_t,s0)
 
 /var/log/mariadb(/.*)?	gen_context(system_u:object_r:mysqld_log_t,s0)
 /var/log/mysql.*	--	gen_context(system_u:object_r:mysqld_log_t,s0)
 
-/var/run/mysqld.*	gen_context(system_u:object_r:mysqld_var_run_t,s0)
-/var/run/mysqlmanager.*	--	gen_context(system_u:object_r:mysqlmanagerd_var_run_t,s0)
-/var/run/mysqld/mysqlmanager.*	--	gen_context(system_u:object_r:mysqlmanagerd_var_run_t,s0)
+/var/run/mariadb(/.*)?      gen_context(system_u:object_r:mysqld_var_run_t,s0)
+/var/run/mysqld(/.*)?		gen_context(system_u:object_r:mysqld_var_run_t,s0)
+/var/run/mysqld/mysqlmanager.* -- gen_context(system_u:object_r:mysqlmanagerd_var_run_t,s0)
Index: serefpolicy-contrib-20140730/mysql.if
===================================================================
--- serefpolicy-contrib-20140730.orig/mysql.if
+++ serefpolicy-contrib-20140730/mysql.if
@@ -1,23 +1,4 @@
-## <summary>Open source database.</summary>
-
-########################################
-## <summary>
-##	Role access for mysql.
-## </summary>
-## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
-## </param>
-## <param name="domain">
-##	<summary>
-##	User domain for the role.
-##	</summary>
-## </param>
-#
-interface(`mysql_role',`
-	refpolicywarn(`$0($*) has been deprecated')
-')
+## <summary>Policy for MySQL</summary>
 
 ######################################
 ## <summary>
@@ -34,38 +15,30 @@ interface(`mysql_domtrans',`
 		type mysqld_t, mysqld_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, mysqld_exec_t, mysqld_t)
 ')
 
-########################################
+######################################
 ## <summary>
-##	Execute mysqld in the mysqld domain, and
-##	allow the specified role the mysqld domain.
+##	Execute MySQL in the caller domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed to transition.
-##	</summary>
-## </param>
-## <param name="role">
-##	<summary>
-##	Role allowed access.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`mysql_run_mysqld',`
+interface(`mysql_exec',`
 	gen_require(`
-		attribute_role mysqld_roles;
+		type  mysqld_exec_t;
 	')
 
-	mysql_domtrans($1)
-	roleattribute $2 mysqld_roles;
+	can_exec($1, mysqld_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	Send generic signals to mysqld.
+##	Send a generic signal to MySQL.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -81,9 +54,27 @@ interface(`mysql_signal',`
 	allow $1 mysqld_t:process signal;
 ')
 
+#######################################
+## <summary>
+##  Send a null signal to mysql.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`mysql_signull',`
+    gen_require(`
+        type mysqld_t;
+    ')
+
+    allow $1 mysqld_t:process signull;
+')
+
 ########################################
 ## <summary>
-##	Connect to mysqld with a tcp socket.
+##	Allow the specified domain to connect to postgresql with a tcp socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -104,8 +95,7 @@ interface(`mysql_tcp_connect',`
 
 ########################################
 ## <summary>
-##	Connect to mysqld with a unix
-#	domain stream socket.
+##	Connect to MySQL using a unix domain stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -120,12 +110,13 @@ interface(`mysql_stream_connect',`
 	')
 
 	files_search_pids($1)
-	stream_connect_pattern($1, { mysqld_db_t mysqld_var_run_t }, mysqld_var_run_t, mysqld_t)
+	stream_connect_pattern($1, mysqld_var_run_t, mysqld_var_run_t, mysqld_t)
+	stream_connect_pattern($1, mysqld_db_t, mysqld_var_run_t, mysqld_t)
 ')
 
 ########################################
 ## <summary>
-##	Read mysqld configuration content.
+##	Read MySQL configuration files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -139,7 +130,6 @@ interface(`mysql_read_config',`
 		type mysqld_etc_t;
 	')
 
-	files_search_etc($1)
 	allow $1 mysqld_etc_t:dir list_dir_perms;
 	allow $1 mysqld_etc_t:file read_file_perms;
 	allow $1 mysqld_etc_t:lnk_file read_lnk_file_perms;
@@ -147,7 +137,8 @@ interface(`mysql_read_config',`
 
 ########################################
 ## <summary>
-##	Search mysqld db directories.
+##	Search the directories that contain MySQL
+##	database storage.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -155,6 +146,8 @@ interface(`mysql_read_config',`
 ##	</summary>
 ## </param>
 #
+# cjp: "_dir" in the name is added to clarify that this
+# is not searching the database itself.
 interface(`mysql_search_db',`
 	gen_require(`
 		type mysqld_db_t;
@@ -166,7 +159,27 @@ interface(`mysql_search_db',`
 
 ########################################
 ## <summary>
-##	Read and write mysqld database directories.
+##	List the directories that contain MySQL
+##	database storage.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`mysql_list_db',`
+	gen_require(`
+		type mysqld_db_t;
+	')
+
+	files_search_var_lib($1)
+	allow $1 mysqld_db_t:dir list_dir_perms;
+')
+
+########################################
+## <summary>
+##	Read and write to the MySQL database directory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -185,8 +198,7 @@ interface(`mysql_rw_db_dirs',`
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	mysqld database directories.
+##	Create, read, write, and delete MySQL database directories.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -205,7 +217,7 @@ interface(`mysql_manage_db_dirs',`
 
 #######################################
 ## <summary>
-##	Append mysqld database files.
+##	Append to the MySQL database directory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -221,10 +233,28 @@ interface(`mysql_append_db_files',`
 	files_search_var_lib($1)
 	append_files_pattern($1, mysqld_db_t, mysqld_db_t)
 ')
+#######################################
+## <summary>
+##	Read and write to the MySQL database directory.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`mysql_read_db_lnk_files',`
+	gen_require(`
+		type mysqld_db_t;
+	')
+
+	files_search_var_lib($1)
+    read_lnk_files_pattern($1, mysqld_db_t, mysqld_db_t)
+')
 
 #######################################
 ## <summary>
-##	Read and write mysqld database files.
+##	Read and write to the MySQL database directory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -243,8 +273,7 @@ interface(`mysql_rw_db_files',`
 
 #######################################
 ## <summary>
-##	Create, read, write, and delete
-##	mysqld database files.
+##	Create, read, write, and delete MySQL database files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -263,7 +292,7 @@ interface(`mysql_manage_db_files',`
 
 ########################################
 ## <summary>
-##	Read and write mysqld database sockets.
+##	Read and write to the MySQL database
 ##	named socket.
 ## </summary>
 ## <param name="domain">
@@ -273,13 +302,18 @@ interface(`mysql_manage_db_files',`
 ## </param>
 #
 interface(`mysql_rw_db_sockets',`
-	refpolicywarn(`$0($*) has been deprecated.')
+	gen_require(`
+		type mysqld_db_t;
+	')
+
+	files_search_var_lib($1)
+	allow $1 mysqld_db_t:dir search_dir_perms;
+	allow $1 mysqld_db_t:sock_file rw_sock_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	mysqld home files.
+##	Write to the MySQL log.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -287,86 +321,92 @@ interface(`mysql_rw_db_sockets',`
 ##	</summary>
 ## </param>
 #
-interface(`mysql_manage_mysqld_home_files',`
+interface(`mysql_write_log',`
 	gen_require(`
-		type mysqld_home_t;
+		type mysqld_log_t;
 	')
 
-	userdom_search_user_home_dirs($1)
-	allow $1 mysqld_home_t:file manage_file_perms;
+	logging_search_logs($1)
+	allow $1 mysqld_log_t:file { write_file_perms setattr_file_perms };
 ')
 
-########################################
+######################################
 ## <summary>
-##	Relabel mysqld home files.
+##	Execute MySQL safe script in the mysql safe domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain allowed to transition.
 ##	</summary>
 ## </param>
 #
-interface(`mysql_relabel_mysqld_home_files',`
+interface(`mysql_domtrans_mysql_safe',`
 	gen_require(`
-		type mysqld_home_t;
+		type mysqld_safe_t, mysqld_safe_exec_t;
 	')
 
-	userdom_search_user_home_dirs($1)
-	allow $1 mysqld_home_t:file relabel_file_perms;
+	domtrans_pattern($1, mysqld_safe_exec_t, mysqld_safe_t)
 ')
 
-########################################
+######################################
 ## <summary>
-##	Create objects in user home
-##	directories with the mysqld home type.
+##	Execute MySQL_safe in the caller domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="object_class">
-##	<summary>
-##	Class of the object being created.
-##	</summary>
-## </param>
-## <param name="name" optional="true">
+#
+interface(`mysql_safe_exec',`
+	gen_require(`
+		type  mysqld_safe_exec_t;
+	')
+
+	can_exec($1, mysqld_safe_exec_t)
+')
+
+#####################################
+## <summary>
+##	Read MySQL PID files.
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	The name of the object being created.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`mysql_home_filetrans_mysqld_home',`
+interface(`mysql_read_pid_files',`
 	gen_require(`
-		type mysqld_home_t;
+		type mysqld_var_run_t;
 	')
 
-	userdom_user_home_dir_filetrans($1, mysqld_home_t, $2, $3)
+	mysql_search_pid_files($1)
+	read_files_pattern($1, mysqld_var_run_t, mysqld_var_run_t)
 ')
 
-########################################
+#####################################
 ## <summary>
-##	Write mysqld log files.
+##	Search MySQL PID files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
+##
 #
-interface(`mysql_write_log',`
+interface(`mysql_search_pid_files',`
 	gen_require(`
-		type mysqld_log_t;
+		type mysqld_var_run_t;
 	')
 
-	logging_search_logs($1)
-	allow $1 mysqld_log_t:file write_file_perms;
+	search_dirs_pattern($1, mysqld_var_run_t, mysqld_var_run_t)
 ')
 
-######################################
+########################################
 ## <summary>
-##	Execute mysqld safe in the
-##	mysqld safe domain.
+##	Execute mysqld server in the mysqld domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -374,18 +414,22 @@ interface(`mysql_write_log',`
 ##	</summary>
 ## </param>
 #
-interface(`mysql_domtrans_mysql_safe',`
+interface(`mysql_systemctl',`
 	gen_require(`
-		type mysqld_safe_t, mysqld_safe_exec_t;
+		type mysqld_unit_file_t;
+		type mysqld_t;
 	')
 
-	corecmd_search_bin($1)
-	domtrans_pattern($1, mysqld_safe_exec_t, mysqld_safe_t)
+	systemd_exec_systemctl($1)
+	allow $1 mysqld_unit_file_t:file read_file_perms;
+	allow $1 mysqld_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, mysqld_t)
 ')
 
-#####################################
+########################################
 ## <summary>
-##	Read mysqld pid files.
+##	read mysqld homedir content (.k5login)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -393,39 +437,37 @@ interface(`mysql_domtrans_mysql_safe',`
 ##	</summary>
 ## </param>
 #
-interface(`mysql_read_pid_files',`
+interface(`mysql_read_home_content',`
 	gen_require(`
-		type mysqld_var_run_t;
+		type mysqld_home_t;
 	')
 
-	files_search_pids($1)
-	read_files_pattern($1, mysqld_var_run_t, mysqld_var_run_t)
+	userdom_search_user_home_dirs($1)
+	read_files_pattern($1, mysqld_home_t, mysqld_home_t)
 ')
 
-#####################################
+########################################
 ## <summary>
-##	Search mysqld pid files.
+##	Transition to mysqld named content
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##      Domain allowed access.
 ##	</summary>
 ## </param>
-##
 #
-interface(`mysql_search_pid_files',`
+interface(`mysql_filetrans_named_content',`
 	gen_require(`
-		type mysqld_var_run_t;
+		type mysqld_home_t;
 	')
 
-	files_search_pids($1)
-	search_dirs_pattern($1, mysqld_var_run_t, mysqld_var_run_t)
+	userdom_admin_home_dir_filetrans($1, mysqld_home_t, file, ".my.cnf")
+	userdom_user_home_dir_filetrans($1, mysqld_home_t, file, ".my.cnf")
 ')
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an mysqld environment.
+##	All of the rules required to administrate an mysql environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -434,41 +476,52 @@ interface(`mysql_search_pid_files',`
 ## </param>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	The role to be allowed to manage the mysql domain.
 ##	</summary>
 ## </param>
 ## <rolecap/>
 #
 interface(`mysql_admin',`
 	gen_require(`
-		type mysqld_t, mysqld_var_run_t, mysqld_etc_t;
+		type mysqld_t, mysqld_var_run_t, mysqld_initrc_exec_t;
 		type mysqld_tmp_t, mysqld_db_t, mysqld_log_t;
-		type mysqld_safe_t, mysqlmanagerd_t, mysqlmanagerd_var_run_t;
-		type mysqld_initrc_exec_t, mysqlmanagerd_initrc_exec_t, mysqld_home_t;
+		type mysqld_etc_t;
+		type mysqld_home_t;
+		type mysqld_unit_file_t;
 	')
 
-	allow $1 { mysqld_safe_t mysqld_t mysqlmanagerd_t }:process { ptrace signal_perms };
-	ps_process_pattern($1, { mysqld_safe_t mysqld_t mysqlmanagerd_t })
+	allow $1 mysqld_t:process signal_perms;
+	ps_process_pattern($1, mysqld_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 mysqld_t:process ptrace;
+	')
 
-	init_labeled_script_domtrans($1, {  mysqlmanagerd_initrc_exec_t mysqld_initrc_exec_t })
+	init_labeled_script_domtrans($1, mysqld_initrc_exec_t)
 	domain_system_change_exemption($1)
-	role_transition $2 { mysqlmanagerd_initrc_exec_t mysqld_initrc_exec_t } system_r;
+	role_transition $2 mysqld_initrc_exec_t system_r;
 	allow $2 system_r;
 
-	files_search_pids($1)
-	admin_pattern($1, { mysqlmanagerd_var_run_t mysqld_var_run_t })
+	files_list_pids($1)
+	admin_pattern($1, mysqld_var_run_t)
 
-	files_search_var_lib($1)
 	admin_pattern($1, mysqld_db_t)
 
-	files_search_etc($1)
-	admin_pattern($1, { mysqld_etc_t mysqld_home_t })
+	files_list_etc($1)
+	admin_pattern($1, mysqld_etc_t)
 
-	logging_search_logs($1)
+	logging_list_logs($1)
 	admin_pattern($1, mysqld_log_t)
 
-	files_search_tmp($1)
+	files_list_tmp($1)
 	admin_pattern($1, mysqld_tmp_t)
 
-	mysql_run_mysqld($1, $2)
+	userdom_search_user_home_dirs($1)
+	files_list_root($1)
+	admin_pattern($1, mysqld_home_t)
+
+	mysql_systemctl($1)
+	admin_pattern($1, mysqld_unit_file_t)
+	allow $1 mysqld_unit_file_t:service all_service_perms;
+
+	mysql_stream_connect($1)
 ')
